#!/usr/bin/env python
# -*- coding: utf-8 -*-

from bson.json_util import dumps
from bson.json_util import loads
from devdoo.validate import Validate


class DataRest_DB():
    def __init__(self, message):
        self.__validate = Validate()
        self.decode(message)

    def action(self):
        return self.__action

    def collection(self):
        return self.__collection

    def data(self):
        return self.__data

    def database(self):
        return self.__database

    def fields(self):
        return self.__fields

    def filter(self):
        return self.__filter

    def limit(self):
        return self.__limit

    def info(self):
        return {
            "owner": {
                "id": self.__token,
                "last_id": self.__token
            }
        }

    # --------------------------------
    # add_error
    # --------------------------------
    def add_error(self, code, message):
        self.__validate.add_error(code, message)

    # --------------------------------
    # ready
    # --------------------------------
    def ready(self):
        return self.__validate.ready()

    # --------------------------------
    # send_error
    # --------------------------------
    def send_error(self):
        message_send = {
            "id": self.__connection_id,
            "success": False,
            "error": self.__validate.error_to_list()
        }

        # Montar mensagem que será enviada para o serviço de banco de dados
        return dumps(message_send)

    # --------------------------------
    # send_service
    # --------------------------------
    def send(self):
        print "SEND RESULT", self.__message_send
        return dumps(self.__message_send)

    # ----------------------------------------------------------------
    #
    # Private Methods
    #
    # ----------------------------------------------------------------
    # --------------------------------
    # decode_service_db
    # --------------------------------
    def decode(self, message):
        # Prepara o pacote a ser enviado
        json = loads(message)

        self.__action = json["action"]
        self.__collection = json["collection"]
        self.__connection_id = json["connection_id"]
        self.__cursor = json["cursor"]
        self.__data = json["data"]
        self.__database = json["database"]
        self.__fields = json["fields"]

        self.__sort = json["sort"]
        self.__service_id = json["service_id"]
        self.__source_id = json["source_id"]
        self.__info = json["info"]

        self.__filter = json["filter"]
        self.__limit = json["limit"]

        self.__validate.add_errors(json["error"])

        print "RECEBE SERVICE", json

        # self.action = json["action"]
        # self.collection_name = json["collection_name"]
        # self.data = dict(json["data"])
        # self.database_name = json["database_name"]
        # self.id = json["id"]
        # self.fields = json["fields"]
        # self.filter = json["filter"]
        # self.limit = json["limit"]
        # self.order = json["order"]
        # self.cursor = json["cursor"]
        # self.error = json["error"]
        # self.source_id = json["source_id"]
        # self.__validate.add_errors(self.error)

    # --------------------------------
    # result
    # --------------------------------
    def result(self, data, conditions=None):
        result = {
            "results": data,
            "response_time": "17.000",
            "server_time": "7.000",
            "success": True,
            "BOL00TESTE": "MALA AZULETA"
        }

        if conditions != None:
            if "success" in conditions.keys():
                result["success"] = conditions["success"]
            if "query" in conditions.keys():
                result["query"] = conditions["query"]
            if "count" in conditions.keys():
                result["count"] = conditions["count"]

        if self.__validate.has_error():
            result["errors"] = self.__validate.error_to_list()

        result["links"] = {
            "previous": None,
            "next": "https://api.predicthq.com/v1/endpoint/?offset=10&limit=10"
        }
        result["cursors"] = {
            "previous": None,
            "next": "B9XAeo1CcAA"
        }
        self.__message_send = {
            "connection_id": self.__connection_id,
            "message": result
        }
